//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  MACIP_CAONX
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/15
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  <Windows.h>
#include  <TChar.h>
#include  <Commctrl.h>
#include  "Resource.h"
#include  "DialogMACIP.h"
#include  "DialogProgress.h"

//////////////////////////////////////////////////////////////////////
//        R[obN֐
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  ց@@   :  DlgMACIPProc
//
//  @@@@\   :  j[_CAO{bNX
//
//  p[^   :  HWND    p_hDlg      <- EChEnh
//                  UINT    p_uMessage  <- bZ[W
//                  WPARAM  p_wParam    <- gp[^
//                  LPARAM  p_lParam    <- gp[^
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
BOOL CALLBACK	DlgMACIPProc(HWND p_hDlg, UINT p_uMessage, WPARAM p_wParam, LPARAM p_lParam)
{
	static DialogMACIP*  pDialog;
	BOOL	fResult = FALSE;

	if (p_uMessage == WM_INITDIALOG)	{
		pDialog = (DialogMACIP*)p_lParam;
		fResult = pDialog->dlgProc(p_hDlg, p_uMessage, p_wParam, p_lParam);
	}
	else	{
		if (pDialog != NULL)	{
			fResult = pDialog->dlgProc(p_hDlg, p_uMessage, p_wParam, p_lParam);
		}
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//        RXgN^/fXgN^
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  DialogMACIP
//
//  @@@@\   :  RXgN^
//
//  p[^   :  HINSTANCE  p_hInstance  <- vOCX^X
//                  HWND       p_hWnd       <- eEChẼnh
//
//  ߁@@l   :  g̃CX^X
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
DialogMACIP::DialogMACIP(HINSTANCE p_hInstance, HWND p_hWnd)
{
	m_hInstanceParent = p_hInstance;
	m_hWndParent = p_hWnd;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  ~DialogMACIP
//
//  @@@@\   :  fXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  Ȃ
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
DialogMACIP::~DialogMACIP()
{
}

//////////////////////////////////////////////////////////////////////
//        pubN\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  createDialogBox
//
//  @@@@\   :  _CAO쐬B
//
//  p[^   :  HWND  p_hDlg  <- EChEnh
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	DialogMACIP::createDialogBox(HWND p_hWnd)
{
	BOOL       fResult = FALSE;
	HINSTANCE  hInstance;
	DLGPROC    pfnDlgProc;

	hInstance = (HINSTANCE)GetWindowLongPtr(p_hWnd, GWLP_HINSTANCE);
	pfnDlgProc = (DLGPROC)DlgMACIPProc;
	INT_PTR npRet = DialogBoxParam(hInstance, MAKEINTRESOURCE(DLGMACIP), p_hWnd, pfnDlgProc, (LPARAM)this);
	if (npRet != -1)	{
		fResult = TRUE;
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  dlgProc
//
//  @@@@\   :  bZ[WCxgsB
//
//  p[^   :  HWND    p_hDlg      <- EChEnh
//                  UINT    p_uMessage  <- bZ[W
//                  WPARAM  p_wParam    <- gp[^
//                  LPARAM  p_lParam    <- gp[^
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	DialogMACIP::dlgProc(HWND p_hDlg, UINT p_uMessage, WPARAM p_wParam, LPARAM p_lParam)
{
	BOOL	fResult;

	switch(p_uMessage)	{
		case WM_INITDIALOG:
			fResult = dlgInit(p_hDlg);
			break;
		case WM_COMMAND:
			fResult = dlgCommand(p_hDlg, p_wParam, p_lParam);
			break;
		default:
			fResult = FALSE;
			break;
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//        vCx[g\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  dlgInit
//
//  @@@@\   :  WM_INITDIALOGsB
//
//  p[^   :  HWND  p_hDlg  <- EChEnh
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
BOOL		DialogMACIP::dlgInit(HWND p_hDlg)
{
	UNREFERENCED_PARAMETER(p_hDlg);

	// 
	InitCommonControls();
	setDialogCenter(p_hDlg);

	// ͐̐
	SendMessage(GetDlgItem(p_hDlg, IDC_MACADDR), EM_SETLIMITTEXT, (WPARAM)c_nInputLength, 0);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  dlgCommand
//
//  @@@@\   :  WM_COMMANDsB
//
//  p[^   :  HWND    p_hDlg    <- EChEnh
//                  WPARAM  p_wParam  <- gp[^
//                  LPARAM  p_lParam  <- gp[^
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	DialogMACIP::dlgCommand(HWND p_hDlg, WPARAM p_wParam, LPARAM p_lParam)
{
	BOOL	fResult = TRUE;

	UNREFERENCED_PARAMETER(p_lParam);
	switch(LOWORD(p_wParam))	{
		case IDOK:								// IPAhX̌
			dlgCommandOK(p_hDlg);
			break;
		case IDCANCEL:							// _CAȌI
			EndDialog(p_hDlg, TRUE);
			break;
		default:
			fResult = FALSE;
			break;
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  dlgCommandOK
//
//  @@@@\   :  WM_COMMANDIDOKB
//
//  p[^   :  HWND    p_hDlg    <- EChEnh
//                  WPARAM  p_wParam  <- gp[^
//                  LPARAM  p_lParam  <- gp[^
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/18   by H.m
//////////////////////////////////////////////////////////////////////
VOID	DialogMACIP::dlgCommandOK(HWND p_hDlg)
{
	TCHAR	tszIpAddress[MAX_PATH];
	TCHAR	tszMacAddress[MAX_PATH];
	HWND	hDlgProgress;
	HWND	hWndProgress;
	BOOL	fSearch;

	// ̓`FbN
	GetDlgItemText(p_hDlg, IDC_MACADDR, tszMacAddress, MAX_PATH);
	if (!checkString(p_hDlg, tszMacAddress)) {
		return;
	}

	// ֎~
	EnableWindow(GetDlgItem(p_hDlg, IDOK), FALSE);
	EnableWindow(GetDlgItem(p_hDlg, IDCANCEL), FALSE);

	// vOXo[쐬
	DialogProgress*	pDialogProgress;
	pDialogProgress = new DialogProgress();
	hDlgProgress = pDialogProgress->createDialogBox(p_hDlg);
	ShowWindow(hDlgProgress, SW_SHOW);
	UpdateWindow(hDlgProgress);

	// vOX̃Wݒ
	hWndProgress = GetDlgItem(hDlgProgress, IDC_PROGRESS);
	SendMessage(hWndProgress, PBM_SETRANGE, 0, MAKELPARAM(c_nProgressMin, c_nProgressMax));

	// IPAhX̌
	GetDlgItemText(p_hDlg, IDC_MACADDR, tszMacAddress, MAX_PATH);
	fSearch = searchIPAddress(tszMacAddress, tszIpAddress, hWndProgress);

	// vOX_CAO̔j
	DestroyWindow(hDlgProgress);
	delete pDialogProgress;

	// ʂ\
	if (fSearch)	{
		SetDlgItemText(p_hDlg, IDC_IPADDR, tszIpAddress);
	}
	else	{
		LoadString(m_hInstanceParent, IDS_NOTFOUND, tszIpAddress, MAX_PATH);
		SetDlgItemText(p_hDlg, IDC_IPADDR, tszIpAddress);
	}

	// L
	EnableWindow(GetDlgItem(p_hDlg, IDOK), TRUE);
	EnableWindow(GetDlgItem(p_hDlg, IDCANCEL), TRUE);

}

//////////////////////////////////////////////////////////////////////
//  \bh   :  checkString
//
//  @@@@\   :  nꂽ񂪐ׂB
//
//  p[^   :  HWND     p_hDlg             <- EChEnh
//                  LPCTSTR  p_pctszMacAddress  <- ͂ꂽMACAhX
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/22   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	DialogMACIP::checkString(HWND p_hDlg, LPCTSTR p_pctszMacAddress)
{
	int		nLength;
	BOOL	fResult = FALSE;

	// 
	nLength = lstrlen(p_pctszMacAddress);
	if (nLength == 0) {
		dispErrorMessage(p_hDlg, ERR_NOTINPUT);
	}
	// Ⴄ
	else if (nLength != c_nInputLength) {
		dispErrorMessage(p_hDlg, ERR_LENGTH);
	}
	// 16iȊO͂Ă
	else if (!checkMacAddress(p_pctszMacAddress, nLength)) {
		dispErrorMessage(p_hDlg, ERR_NUMERIC);
	}
	else	{
		fResult = TRUE;
	}
	return fResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  checkMacAddress
//
//  @@@@\   :  ͂ꂽMACAhXׂB
//
//  p[^   :  HWND     p_hDlg             <- EChEnh
//                  LPCTSTR  p_pctszMacAddress  <- ͂ꂽMACAhX
//
//  ߁@@l   :  BOOL
//
//  @@   :  2020/ 3/22   by H.m
//////////////////////////////////////////////////////////////////////
BOOL	DialogMACIP::checkMacAddress(LPCTSTR p_pctszMacAddress, int p_nLength)
{
	int		nSel;
	TCHAR	tChar;
	BOOL	fResult = TRUE;

	for (nSel = 0; nSel < p_nLength; nSel++) {
		tChar = p_pctszMacAddress[nSel];
		// 0`9 | :
		if (!(tChar <= (TCHAR)0x003a && tChar >= (TCHAR)0x0030)) {
			// A`F
			if (!(tChar <= (TCHAR)0x0046 && tChar >= (TCHAR)0x0041)) {
				// a`f
				if (!(tChar <= (TCHAR)0x0066 && tChar >= (TCHAR)0x0061)) {
					fResult = FALSE;
					break;
				}
			}
		}
	}
	return fResult;
}
