//////////////////////////////////////////////////////////////////////
//  vWFNg  :  MAC2IP
//
//  t@C  :  IPAhX_CAONX
//
//  J      :  Visual Studio 2019
//
//  @@    :  2020/ 3/14
//
//  @@    :  ElementTech  Hidetoshi Matsui
//////////////////////////////////////////////////////////////////////
#include  <Windows.h>
#include  "Resource.h"
#include  "MAC2IPClass.h"
#include  "DialogMACIP.h"
#include  "DialogVersion.h"

//////////////////////////////////////////////////////////////////////
//        RXgN^/fXgN^
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  MACIPClass
//
//  @@@@\   :  RXgN^
//
//  p[^   :  HINSTANCE  hInstance  <- vOCX^X
//
//  ߁@@l   :  g̃CX^X
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
MACIPClass::MACIPClass(HINSTANCE p_hInstance)
{
	m_hInstance = p_hInstance;
	m_hWnd	= NULL;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  ~MACIPClass
//
//  @@@@\   :  fXgN^
//
//  p[^   :  Ȃ
//
//  ߁@@l   :  Ȃ
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
MACIPClass::~MACIPClass()
{
}

//////////////////////////////////////////////////////////////////////
//        pubN\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  wndProc
//
//  @@@@\   :  bZ[WCxg
//
//  p[^   :  HWND    p_hWnd      <- nh
//                  UINT    p_uMessage  <- bZ[W
//                  WPARAM  p_wParam    <- p[^
//                  LPARAM  p_lParam    <- gp[^
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT MACIPClass::wndProc(HWND p_hWnd, UINT p_uMessage, WPARAM p_wParam, LPARAM p_lParam)
{
	LRESULT	lResult = 0;

	switch (p_uMessage)	{
	case WM_CREATE:
		lResult = wndProcCreate(p_hWnd, p_lParam);
		break;
	case WM_DESTROY:
		lResult = wndProcDestroy(p_hWnd);
		break;
	case WM_QUERYENDSESSION:
		lResult = wndProcDestroy(p_hWnd);
		break;
	case WM_COMMAND:
		lResult = wndProcCommand(p_hWnd, p_uMessage, p_wParam, p_lParam);
		break;
	default:
		lResult = DefWindowProc(p_hWnd, p_uMessage, p_wParam, p_lParam);
		break;
	}
	return lResult;
}

//////////////////////////////////////////////////////////////////////
//        vCx[g\bh
//////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////
//  \bh   :  wndProcCreate
//
//  @@@@\   :  WM_CREATEB
//
//  p[^   :  HWND    p_hWnd    <- EBhEnh
//                  LPARAM  p_lParam  <- gp[^(NXCX^X)
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndProcCreate(HWND p_hWnd, LPARAM p_lParam)
{
	// gpp[^̑Ή
	UNREFERENCED_PARAMETER(p_lParam);

	// ϊp_CAO쐬
	PostMessage(p_hWnd, WM_COMMAND, IDM_MAIN, NULL);

	return 0;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  wndProcDestroy
//
//  @@@@\   :  WM_DESTROYB
//
//  p[^   :  HWND  p_hWnd  <- EBhEnh
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndProcDestroy(HWND p_hWnd)
{
	UNREFERENCED_PARAMETER(p_hWnd);

	PostQuitMessage(0);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  wndProcCommand
//
//  @@@@\   :  WM_COMMANDB
//
//  p[^   :  HWND    hWnd    <- EBhEnh
//                  WPARAM  wParam  <- p[^
//                  LPARAM  lParam  <- gp[^
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndProcCommand(HWND p_hWnd, UINT p_message, WPARAM p_wParam, LPARAM p_lParam)
{
	LRESULT	lResult = 0;

	// Iꂽj[s
	switch (LOWORD(p_wParam))	{
	case IDM_MAIN:
		lResult = wndCommandMain(p_hWnd);
		break;
	case IDM_EXIT:
		lResult = wndCommandDestroy(p_hWnd);
		break;
	case IDM_ABOUT:
		lResult = wndCommandAbout(p_hWnd);
		break;
	default:
		lResult = DefWindowProc(p_hWnd, p_message, p_wParam, p_lParam);
	}
	return lResult;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  wndCommandMain
//
//  @@@@\   :  WM_COMMANDIDM_MAINB
//
//  p[^   :  HWND  hWnd  <- EBhEnh
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/14   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndCommandMain(HWND p_hWnd)
{
	DialogMACIP*	pDialog;

	// C_CAO쐬
	pDialog = new DialogMACIP(m_hInstance, p_hWnd);
	pDialog->createDialogBox(p_hWnd);
	delete pDialog;

	// vOI
	PostMessage(p_hWnd, WM_COMMAND, IDM_EXIT, NULL);

	return 0;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  wndCommandDestroy
//
//  @@@@\   :  WM_COMMANDIDM_EXITB
//
//  p[^   :  HWND   hWnd  <- EBhEnh
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndCommandDestroy(HWND p_hWnd)
{
	DestroyWindow(p_hWnd);

	return 0;
}

//////////////////////////////////////////////////////////////////////
//  \bh   :  wndCommandAbout
//
//  @@@@\   :  WM_COMMANDIDM_ABOUTB
//
//  p[^   :  HWND  hWnd  <- EBhEnh
//
//  ߁@@l   :  LRESULT
//
//  @@   :  2020/ 3/13   by H.m
//////////////////////////////////////////////////////////////////////
LRESULT	MACIPClass::wndCommandAbout(HWND p_hWnd)
{
	DialogVersion*	pDialogVersion;

	pDialogVersion = new DialogVersion();
	pDialogVersion->createDialogBox(p_hWnd);
	delete pDialogVersion;

	return 0;
}

